diff -ruN ../nakedmudv2.7/src/mud.h src/mud.h
--- ../nakedmudv2.7/src/mud.h	Sun Jul 31 17:13:53 2005
+++ src/mud.h	Fri Oct  7 14:15:55 2005
@@ -8,8 +8,6 @@
 // include this header.
 //
 //*****************************************************************************
-#include <zlib.h>
-#include <pthread.h>
 #include <arpa/telnet.h>
 #include "wrapsock.h"
 
@@ -45,7 +43,6 @@
 typedef struct socket_data                SOCKET_DATA;
 typedef struct account_data               ACCOUNT_DATA;
 typedef struct char_data                  CHAR_DATA;  
-typedef struct datatable                  DATATABLE;
 typedef struct storage_set                STORAGE_SET;
 typedef struct storage_set_list           STORAGE_SET_LIST;
 typedef struct prototype_data             PROTO_DATA;
@@ -54,7 +51,6 @@
 typedef struct edesc_data                 EDESC_DATA;
 typedef struct edesc_set_data             EDESC_SET;
 typedef struct response_data              RESPONSE_DATA;
-typedef struct dialog_data                DIALOG_DATA;
 
 typedef struct script_data                SCRIPT_DATA;
 typedef struct world_data                 WORLD_DATA;
@@ -65,6 +61,7 @@
 typedef struct shop_data                  SHOP_DATA;
 typedef struct body_data                  BODY_DATA;
 typedef struct reset_data                 RESET_DATA;
+typedef struct reset_list                 RESET_LIST;
 
 typedef long                              bitvector_t;
 typedef unsigned char                     bool;
@@ -79,10 +76,13 @@
 #include "property_table.h"
 #include "list.h"
 #include "map.h"
+#include "near_map.h"
 #include "hashtable.h"
 #include "set.h"
 #include "buffer.h"
 #include "bitvector.h"
+#include "parse.h"
+#include "command.h"
 
 
 
@@ -102,12 +102,13 @@
 #define eBOLD   1
 
 /* A few globals */
-#define PULSES_PER_SECOND    10                   /* must divide 1000 : 4, 5 or 8 works */
+#define DFLT_PULSES_PER_SECOND 10
+#define PULSES_PER_SECOND   mudsettingGetInt("pulses_per_second")
 #define SECOND              * PULSES_PER_SECOND   /* used for figuring out how many pulses in a second*/
 #define SECONDS             SECOND                /* same as above */
 #define MINUTE              * 60 SECONDS          /* one minute */
 #define MINUTES             MINUTE
-#define MAX_INPUT_LEN       512                   /* max length of a string someone can input */
+#define MAX_INPUT_LEN      1024                   /* max length of a string someone can input */
 #define SMALL_BUFFER       1024
 #define MAX_BUFFER         8192                   /* seems like a decent amount         */
 #define MAX_SCRIPT         16384                  /* max length of a script */
@@ -116,6 +117,8 @@
 #define COPYOVER_FILE      "../.copyover.dat"     /* tempfile to store copyover data    */
 #define EXE_FILE           "../src/NakedMud"      /* the name of the mud binary         */
 #define DEFAULT_PORT       4000                   /* the default port we run on */
+#define SCREEN_WIDTH       80                     // the width of a term screen
+#define PARA_INDENT        3                      // num of spaces to start para
 
 /* Thread States */
 #define TSTATE_LOOKUP          0  /* Socket is in host_lookup        */
@@ -128,10 +131,10 @@
 #define COMM_GLOBAL            1  /* all over the game               */
 #define COMM_LOG              10  /* admins only                     */
 
-
-#define NOWHERE        (-1)
-#define NOTHING        (-1)
-#define NOBODY         (-1)
+// these are there UIDs for things that have not yet been created
+#define NOBODY               (-1)
+#define NOTHING              (-1)
+#define NOWHERE              (-1)
 
 #define SOMWHERE        "somewhere"
 #define SOMETHING       "something"
@@ -139,26 +142,25 @@
 #define NOTHING_SPECIAL "you see nothing special."
 
 // the room that new characters are dropped into
-#define START_ROOM      100
+#define START_ROOM      mudsettingGetString("start_room")
+#define DFLT_START_ROOM "tavern_entrance@examples"
 
 #define WORLD_PATH     "../lib/world"
 
 
 
-
 //*****************************************************************************
 // core functions for working with new commands
 //*****************************************************************************
-#define CMD_PTR(name)      void (* name)(CHAR_DATA *ch, const char *cmd, \
-					 int subcmd, char *arg)
-#define COMMAND(name)      void name(CHAR_DATA *ch, const char *cmd, \
-				     int subcmd, char *arg)
 void init_commands();
 void show_commands(CHAR_DATA *ch, const char *user_groups);
 void remove_cmd   (const char *cmd);
-void add_cmd      (const char *cmd, const char *sort_by, void *func, 
-	           int subcmd, int min_pos, int max_pos,
-	           const char *user_group, bool mob_ok, bool interrupts);
+void add_cmd      (const char *cmd, const char *sort_by, COMMAND(func),
+	           int min_pos, int max_pos, const char *user_group, 
+		   bool mob_ok, bool interrupts);
+void add_py_cmd   (const char *cmd, const char *sort_by, void *pyfunc,
+		   int min_pos, int max_pos, const char *user_group,
+		   bool mob_ok, bool interrupts);
 bool cmd_exists   (const char *cmd);
 
 
@@ -193,25 +195,28 @@
 //*****************************************************************************
 // Global Variables
 //*****************************************************************************
-extern  LIST           *object_list;
-extern  PROPERTY_TABLE *obj_table;      /* same contents as object_list, but
-					   arranged by uid (unique ID)        */
-extern  LIST           *socket_list;
-extern  LIST           *mobile_list;
-extern  LIST           *mobs_to_delete;    // mobs/objs that have had extraction
-extern  LIST           *objs_to_delete;    // and now need extract_final
-extern  LIST           *extract_obj_funcs; // functions called on obj extraction
-extern  LIST           *extract_mob_funcs; // functions called on mob extraction
-extern  PROPERTY_TABLE *mob_table;      /* same contents as mobile_list, but
-					   arranged by uid (unique ID)        */
-extern  bool            shut_down;      /* used for shutdown                  */
-extern  int             mudport;        /* What port are we running on?       */
-extern  char        *   greeting;       /* the welcome greeting               */
-extern  char        *   motd;           /* the MOTD message                   */
-extern  int             control;        /* boot control socket thingy         */
-extern  time_t          current_time;   /* let's cut down on calls to time()  */
+extern  LIST             *object_list; // all objects currently in the game
+extern  LIST             *socket_list; // all sockets currently conencted
+extern  LIST             *mobile_list; // all mobiles currently in the game
+extern  LIST               *room_list; // all rooms currently in the game
+
+extern  LIST          *mobs_to_delete; // mobs/objs/rooms that have had
+extern  LIST          *objs_to_delete; // extraction and now need 
+extern  LIST         *rooms_to_delete; // extract_final
+
+extern  PROPERTY_TABLE     *mob_table; // a mapping between uid and mob
+extern  PROPERTY_TABLE     *obj_table; // a mapping between uid and obj
+extern  PROPERTY_TABLE    *room_table; // a mapping between uid and room
+extern  PROPERTY_TABLE    *exit_table; // a mapping between uid and exit
+
+extern  bool                shut_down; // used for shutdown
+extern  int                   mudport; // What port are we running on?
+extern  BUFFER              *greeting; // the welcome greeting
+extern  BUFFER                  *motd; // the MOTD message
+extern  int                   control; // boot control socket thingy
+extern  time_t           current_time; // let's cut down on calls to time()
 
-extern WORLD_DATA    *   gameworld;     // the world of the game
+extern  WORLD_DATA         *gameworld; // database and thing that holds rooms
 
 
 
@@ -241,24 +246,15 @@
 void account_menu             ( SOCKET_DATA *sock);
 
 
-//
-// Some command scripts may want to re-force a character to
-// perform the command. In that case, scripts_ok can be
-// set to FALSE so that the command script doesn't re-run
-void  do_cmd                  ( CHAR_DATA *ch, char *arg, 
-				bool scripts_ok, bool aliases_ok);
+void  do_cmd                  ( CHAR_DATA *ch, char *arg, bool aliases_ok);
 
 /* io.c */
 void    log_string            ( const char *txt, ... ) __attribute__ ((format (printf, 1, 2)));
 void    bug                   ( const char *txt, ... ) __attribute__ ((format (printf, 1, 2)));
-char   *read_file             ( const char *file );
-char   *fread_line            ( FILE *fp );                 /* pointer        */
-char   *fread_string          ( FILE *fp );                 /* allocated data */
-char   *fread_word            ( FILE *fp );                 /* pointer        */
-int     fread_number          ( FILE *fp );                 /* just an integer*/
-long    fread_long            ( FILE *fp );                 /* a long integer */
+BUFFER *read_file             ( const char *file );
 
 /* strings.c */
+const char *one_arg_safe      ( const char *fStr, char *bStr );
 char   *one_arg               ( char *fStr, char *bStr );
 char   *two_args              ( char *from, char *arg1, char *arg2);
 char   *three_args            ( char *from, char *arg1, char *arg2, char *arg3);
diff -ruN ../nakedmudv2.7/src/near_map.c src/near_map.c
--- ../nakedmudv2.7/src/near_map.c	Wed Dec 31 17:00:00 1969
+++ src/near_map.c	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,247 @@
+//*****************************************************************************
+//
+// near_map.c
+//
+// hash tables (and maps, more broadly speaking) map a key to a value. The
+// value can only be retreived by using the key. However, there's some cases
+// where we'd like to be lazy about providing the proper key and instead be
+// provided with the "best match". For instance, looking up help files or
+// commands. For the north command, we'd like "n", "no", "nor", nort", and 
+// "north" to all be viable commands. This is what a near-map tries to
+// accomplish.
+//
+//*****************************************************************************
+
+#include "mud.h"
+#include "utils.h"
+#include "near_map.h"
+
+
+
+//*****************************************************************************
+// local datastructures, functions, and defines
+//*****************************************************************************
+#define NUM_NEAR_MAP_BUCKETS   27 // 26 for letters, 1 for non-alpha
+
+struct near_map {
+  LIST *bucket[NUM_NEAR_MAP_BUCKETS];
+};
+
+struct near_iterator {
+  NEAR_MAP         *map;
+  LIST_ITERATOR *curr_i;
+  int         curr_buck;
+};
+
+typedef struct {
+  char        *key;
+  char *min_abbrev;
+  void       *data;
+} NEAR_MAP_ELEM;
+
+
+NEAR_MAP_ELEM *newNearMapElem(void *data, const char *key, 
+			      const char *min_abbrev) {
+  NEAR_MAP_ELEM *elem = malloc(sizeof(NEAR_MAP_ELEM));
+  elem->data          = data;
+  elem->key           = strdupsafe(key);
+  elem->min_abbrev    = strdupsafe(min_abbrev ? min_abbrev : key);
+  return elem;
+}
+
+void deleteNearMapElem(NEAR_MAP_ELEM *elem) {
+  if(elem->key)        free(elem->key);
+  if(elem->min_abbrev) free(elem->min_abbrev);
+  free(elem);
+}
+
+
+//
+// returns the bucket that the key should map into
+int get_nearmap_bucket(const char *key) {
+  if(isalpha(*key))
+    return 1 + tolower(*key) - 'a';
+  else
+    return 0;
+}
+
+int nearmapsortbycmp(NEAR_MAP_ELEM *elem1, NEAR_MAP_ELEM *elem2) {
+  return strcasecmp(elem1->min_abbrev, elem2->min_abbrev);
+}
+
+int is_near_map_abbrev(const char *abbrev, NEAR_MAP_ELEM *elem) {
+  return strncasecmp(abbrev, elem->key, strlen(abbrev));
+}
+
+int is_near_map_elem(const char *key, NEAR_MAP_ELEM *elem) {
+  return strcasecmp(key, elem->key);
+}
+
+
+
+//*****************************************************************************
+// implementation of near_map.h
+//*****************************************************************************
+NEAR_MAP *newNearMap(void) {
+  NEAR_MAP *map = calloc(1, sizeof(NEAR_MAP));
+  return map;
+}
+
+void deleteNearMap(NEAR_MAP *map) {
+  int i;
+  for(i = 0; i < NUM_NEAR_MAP_BUCKETS; i++)
+    if(map->bucket[i] != NULL)
+      deleteListWith(map->bucket[i], deleteNearMapElem);
+  free(map);
+}
+
+void *nearMapGet(NEAR_MAP *map, const char *key, bool abbrev_ok) {
+  // find the bucket
+  LIST *buck = map->bucket[get_nearmap_bucket(key)];
+  if(buck == NULL)
+    return NULL;
+  else {
+    NEAR_MAP_ELEM *elem = NULL;
+    if(abbrev_ok)
+      elem = listGetWith(buck, key, is_near_map_abbrev);
+    else
+      elem = listGetWith(buck, key, is_near_map_elem);
+    return (elem ? elem->data : NULL);
+  }
+}
+
+void nearMapPut(NEAR_MAP *map, const char *key, const char *min_abbrev, 
+		void *elem) {
+  // find the bucket
+  int buck_num = get_nearmap_bucket(key);
+  LIST   *buck = map->bucket[buck_num];
+  if(buck == NULL)
+    map->bucket[buck_num] = buck = newList();
+
+  NEAR_MAP_ELEM *e = newNearMapElem(elem, key, min_abbrev);
+  listPutWith(buck, e, nearmapsortbycmp);
+}
+
+bool nearMapKeyExists(NEAR_MAP *map, const char *key) {
+  return (nearMapGet(map, key, TRUE) != NULL);
+}
+
+void *nearMapRemove(NEAR_MAP *map, const char *key) {
+  LIST *buck = map->bucket[get_nearmap_bucket(key)];
+  if(buck == NULL)
+    return NULL;
+  else {
+    NEAR_MAP_ELEM *elem = listRemoveWith(buck, key, is_near_map_elem);
+    void          *data = NULL;
+    if(elem != NULL) {
+      data = elem->data;
+      deleteNearMapElem(elem);
+    }
+    return data;
+  }
+}
+
+LIST *nearMapGetAllMatches(NEAR_MAP *map, const char *key) {
+  // find the bucket
+  LIST    *buck = map->bucket[get_nearmap_bucket(key)];
+  if(buck == NULL)
+    return NULL;
+  else {
+    LIST         *matches = newList();
+    LIST_ITERATOR *elem_i = newListIterator(buck);
+    NEAR_MAP_ELEM   *elem = NULL;
+    ITERATE_LIST(elem, elem_i) {
+      if(startswith(elem->key, key))
+	listQueue(matches, elem->data);
+    } deleteListIterator(elem_i);
+    // did we find something?
+    if(listSize(matches) == 0) {
+      deleteList(matches);
+      matches = NULL;
+    }
+    return matches;
+  }
+}
+
+
+
+//*****************************************************************************
+// implementation of near map iterator
+//*****************************************************************************
+NEAR_ITERATOR *newNearIterator(NEAR_MAP *map) {
+  NEAR_ITERATOR *iter = calloc(1, sizeof(NEAR_ITERATOR));
+  iter->map           = map;
+  nearIteratorReset(iter);
+  return iter;
+}
+
+void deleteNearIterator(NEAR_ITERATOR *iter) {
+  if(iter->curr_i)
+    deleteListIterator(iter->curr_i);
+  free(iter);
+}
+
+void nearIteratorReset(NEAR_ITERATOR *iter) {
+  int i;
+
+  if(iter->curr_i)
+    deleteListIterator(iter->curr_i);
+  iter->curr_i = NULL;
+  iter->curr_buck = 0;
+
+  // curr_i will be NULL if there are no elems
+  for(i = 0; i < NUM_NEAR_MAP_BUCKETS; i++) {
+    if(iter->map->bucket[i] != NULL && listSize(iter->map->bucket[i]) > 0) {
+      iter->curr_i = newListIterator(iter->map->bucket[i]);
+      iter->curr_buck = i;
+      break;
+    }
+  }
+}
+
+void nearIteratorNext(NEAR_ITERATOR *iter) {
+  // no more elements left
+  if(iter->curr_i == NULL)
+    return;
+  // we're at the end of our list
+  else if(listIteratorNext(iter->curr_i) == NULL) {
+    deleteListIterator(iter->curr_i);
+    iter->curr_i = NULL;
+    iter->curr_buck++;
+
+    for(; iter->curr_buck < NUM_NEAR_MAP_BUCKETS; iter->curr_buck++) {
+      if(iter->map->bucket[iter->curr_buck] != NULL &&
+	 listSize(iter->map->bucket[iter->curr_buck]) > 0) {
+	iter->curr_i = newListIterator(iter->map->bucket[iter->curr_buck]);
+	break;
+      }
+    }
+  }
+}
+
+const char *nearIteratorCurrentKey(NEAR_ITERATOR *iter) {
+  if(iter->curr_i == NULL)
+    return NULL;
+  else {
+    NEAR_MAP_ELEM *elem = listIteratorCurrent(iter->curr_i);
+    return (elem ? elem->key : NULL);
+  }
+}
+
+const char *nearIteratorCurrentAbbrev(NEAR_ITERATOR *iter) {
+  if(iter->curr_i == NULL)
+    return NULL;
+  else {
+    NEAR_MAP_ELEM *elem = listIteratorCurrent(iter->curr_i);
+    return (elem ? elem->min_abbrev : NULL);
+  }
+}
+
+void *nearIteratorCurrentVal(NEAR_ITERATOR *iter) {
+  if(iter->curr_i == NULL)
+    return NULL;
+  else {
+    NEAR_MAP_ELEM *elem = listIteratorCurrent(iter->curr_i);
+    return (elem ? elem->data : NULL);
+  }
+}
diff -ruN ../nakedmudv2.7/src/near_map.h src/near_map.h
--- ../nakedmudv2.7/src/near_map.h	Wed Dec 31 17:00:00 1969
+++ src/near_map.h	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,50 @@
+#ifndef NEAR_MAP_H
+#define NEAR_MAP_H
+//*****************************************************************************
+//
+// near_map.h
+//
+// hash tables (and maps, more broadly speaking) map a key to a value. The
+// value can only be retreived by using the key. However, there's some cases
+// where we'd like to be lazy about providing the proper key and instead be
+// provided with the "best match". For instance, looking up help files or
+// commands. For the north command, we'd like "n", "no", "nor", nort", and 
+// "north" to all be viable commands. This is what a near-map tries to
+// accomplish.
+//
+//*****************************************************************************
+
+typedef struct near_map           NEAR_MAP;
+typedef struct near_iterator NEAR_ITERATOR;
+
+NEAR_MAP        *newNearMap(void);
+void          deleteNearMap(NEAR_MAP *map);
+void            *nearMapGet(NEAR_MAP *map, const char *key, bool abbrev_ok);
+void             nearMapPut(NEAR_MAP *map, const char *key, 
+			    const char *min_abbrev, void *data);
+bool       nearMapKeyExists(NEAR_MAP *map, const char *key);
+void         *nearMapRemove(NEAR_MAP *map, const char *key);
+LIST  *nearMapGetAllMatches(NEAR_MAP *map, const char *key);
+
+
+
+//*****************************************************************************
+// an iterator for going over all entries in a near-map
+//*****************************************************************************
+
+// iterate across all the elements in a near map
+#define ITERATE_NEARMAP(abbrev, val, it) \
+  for(abbrev = nearIteratorCurrentAbbrev(it), val = nearIteratorCurrentVal(it);\
+      abbrev != NULL; \
+      nearIteratorNext(it), \
+      abbrev = nearIteratorCurrentAbbrev(it), val = nearIteratorCurrentVal(it))
+
+NEAR_ITERATOR        *newNearIterator(NEAR_MAP *map);
+void               deleteNearIterator(NEAR_ITERATOR *I);
+void                nearIteratorReset(NEAR_ITERATOR *I);
+void                 nearIteratorNext(NEAR_ITERATOR *I);
+const char    *nearIteratorCurrentKey(NEAR_ITERATOR *I);
+const char *nearIteratorCurrentAbbrev(NEAR_ITERATOR *I);
+void          *nearIteratorCurrentVal(NEAR_ITERATOR *I);
+
+#endif // NEAR_MAP_H
diff -ruN ../nakedmudv2.7/src/object.c src/object.c
--- ../nakedmudv2.7/src/object.c	Sun Jul 31 17:13:53 2005
+++ src/object.c	Fri Oct  7 14:15:55 2005
@@ -14,7 +14,6 @@
 #include "mud.h"
 #include "extra_descs.h"
 #include "utils.h"
-#include "body.h"
 #include "handler.h"
 #include "storage.h"
 #include "auxiliary.h"
@@ -27,11 +26,12 @@
 
 
 struct object_data {
-  int vnum;                 // our number for builders
   int      uid;                  // our unique identifier
   double   weight;               // how much do we weigh, minus contents
   
   char *name;                    // our name - e.g. "a shirt"
+  char *prototypes;              // a list of the types we're instances of
+  char *class;                   // the prototype we most directly inherit from
   char *keywords;                // words to reference us by
   char *rdesc;                   // our room description
   char *multi_name;              // our name when more than 1 appears
@@ -57,11 +57,12 @@
 OBJ_DATA *newObj() {
   OBJ_DATA *obj = calloc(1, sizeof(OBJ_DATA));
   obj->uid            = next_obj_uid++;
-  obj->vnum           = NOTHING;
 
   obj->weight         = 0.1;
 
   obj->bits           = bitvectorInstanceOf("obj_bits");
+  obj->prototypes     = strdup("");
+  obj->class          = strdup("");
   obj->name           = strdup("");
   obj->keywords       = strdup("");
   obj->rdesc          = strdup("");
@@ -86,6 +87,8 @@
   // same goes for users
   deleteList(obj->users);
 
+  if(obj->class)      free(obj->class);
+  if(obj->prototypes) free(obj->prototypes);
   if(obj->name)       free(obj->name);
   if(obj->keywords)   free(obj->keywords);
   if(obj->rdesc)      free(obj->rdesc);
@@ -102,7 +105,8 @@
 
 OBJ_DATA *objRead(STORAGE_SET *set) {
   OBJ_DATA *obj = newObj();
-  objSetVnum(obj,               read_int(set, "vnum"));
+  objSetClass(obj,           read_string(set, "class"));
+  objSetPrototypes(obj,      read_string(set, "prototypes"));
   objSetWeightRaw(obj,       read_double(set, "weight"));
   objSetName(obj,            read_string(set, "name"));
   objSetKeywords(obj,        read_string(set, "keywords"));
@@ -131,7 +135,8 @@
 
 STORAGE_SET *objStore(OBJ_DATA *obj) {
   STORAGE_SET *set = new_storage_set();
-  store_int   (set, "vnum",      obj->vnum);
+  store_string(set, "class",     obj->class);
+  store_string(set, "prototypes",obj->prototypes);
   store_double(set, "weight",    obj->weight);
   store_string(set, "name",      obj->name);
   store_string(set, "keywords",  obj->keywords);
@@ -150,7 +155,8 @@
 
 void objCopyTo(OBJ_DATA *from, OBJ_DATA *to) {
   objSetWeightRaw (to, objGetWeightRaw(from));
-  objSetVnum      (to, objGetVnum(from));
+  objSetClass     (to, objGetClass(from));
+  objSetPrototypes(to, objGetPrototypes(from));
   objSetName      (to, objGetName(from));
   objSetKeywords  (to, objGetKeywords(from));
   objSetRdesc     (to, objGetRdesc(from));
@@ -168,11 +174,14 @@
   return newobj;
 }
 
+bool objIsInstance(OBJ_DATA *obj, const char *prototype) {
+  return is_keyword(obj->prototypes, prototype, FALSE);
+}
+
 bool objIsName(OBJ_DATA *obj, const char *name) {
   return is_keyword(obj->keywords, name, TRUE);
 }
 
-
 void objAddChar(OBJ_DATA *obj, CHAR_DATA *ch) {
   listPut(obj->users, ch);
 }
@@ -196,8 +205,12 @@
   return obj->users;
 }
 
-int objGetVnum(OBJ_DATA *obj) {
-  return obj->vnum;
+const char *objGetClass(OBJ_DATA *obj) {
+  return obj->class;
+}
+
+const char *objGetPrototypes(OBJ_DATA *obj) {
+  return obj->prototypes;
 }
 
 const char *objGetName(OBJ_DATA *obj) {
@@ -283,23 +296,33 @@
   return hashGet(obj->auxiliary_data, name);
 }
 
-void objSetVnum(OBJ_DATA *obj, int vnum) {
-  obj->vnum = vnum;
-}
-
 void objSetKeywords(OBJ_DATA *obj, const char *keywords) {
   if(obj->keywords) free(obj->keywords);
-  obj->keywords = strdup(keywords ? keywords : "");
+  obj->keywords = strdupsafe(keywords);
 }
 
 void objSetRdesc(OBJ_DATA *obj, const char *rdesc) {
   if(obj->rdesc) free(obj->rdesc);
-  obj->rdesc = strdup(rdesc ? rdesc : "");
+  obj->rdesc = strdupsafe(rdesc);
+}
+
+void objSetClass(OBJ_DATA *obj, const char *prototype) {
+  if(obj->class) free(obj->class);
+  obj->class = strdupsafe(prototype);
+}
+
+void objSetPrototypes(OBJ_DATA *obj, const char *prototypes) {
+  if(obj->prototypes) free(obj->prototypes);
+  obj->prototypes = strdupsafe(obj->prototypes);
+}
+
+void objAddPrototype(OBJ_DATA *obj, const char *prototype) {
+  add_keyword(&obj->prototypes, prototype);
 }
 
 void objSetName(OBJ_DATA *obj, const char *name) {
   if(obj->name) free(obj->name);
-  obj->name = strdup(name ? name : "");
+  obj->name = strdupsafe(name);
 }
 
 void objSetDesc(OBJ_DATA *obj, const char *desc) {
@@ -309,12 +332,12 @@
 
 void objSetMultiName(OBJ_DATA *obj, const char *multi_name) {
   if(obj->multi_name) free(obj->multi_name);
-  obj->multi_name = strdup(multi_name ? multi_name : "");
+  obj->multi_name = strdupsafe(multi_name);
 }
 
 void objSetMultiRdesc(OBJ_DATA *obj, const char *multi_rdesc) {
   if(obj->multi_rdesc) free(obj->multi_rdesc);
-  obj->multi_rdesc = strdup(multi_rdesc ? multi_rdesc : "");
+  obj->multi_rdesc = strdupsafe(multi_rdesc);
 }
 
 void objSetEdescs(OBJ_DATA *obj, EDESC_SET *edescs) {
diff -ruN ../nakedmudv2.7/src/object.h src/object.h
--- ../nakedmudv2.7/src/object.h	Sun Jul 31 17:13:53 2005
+++ src/object.h	Fri Oct  7 14:15:55 2005
@@ -23,6 +23,7 @@
 void         objCopyTo      (OBJ_DATA *from, OBJ_DATA *to);
 OBJ_DATA    *objCopy        (OBJ_DATA *obj);
 
+bool         objIsInstance  (OBJ_DATA *obj, const char *prototype);
 bool         objIsName      (OBJ_DATA *obj, const char *name);
 void         objAddChar     (OBJ_DATA *obj, CHAR_DATA *ch);
 void         objRemoveChar  (OBJ_DATA *obj, CHAR_DATA *ch);
@@ -30,11 +31,10 @@
 
 
 //*****************************************************************************
-//
 // set and get functions
-//
 //*****************************************************************************
-int     objGetVnum      (OBJ_DATA *obj);
+const char  *objGetClass     (OBJ_DATA *obj);
+const char  *objGetPrototypes(OBJ_DATA *obj);
 const char  *objGetName      (OBJ_DATA *obj);
 const char  *objGetKeywords  (OBJ_DATA *obj);
 const char  *objGetRdesc     (OBJ_DATA *obj);
@@ -43,6 +43,7 @@
 const char  *objGetMultiRdesc(OBJ_DATA *obj);
 EDESC_SET   *objGetEdescs    (OBJ_DATA *obj);
 const char  *objGetEdesc     (OBJ_DATA *obj, const char *keyword);
+const char  *objGetInstances (OBJ_DATA *obj);
 BUFFER      *objGetDescBuffer(OBJ_DATA *obj);
 CHAR_DATA   *objGetCarrier   (OBJ_DATA *obj);
 CHAR_DATA   *objGetWearer    (OBJ_DATA *obj);
@@ -56,7 +57,9 @@
 void        *objGetAuxiliaryData(const OBJ_DATA *obj, const char *name);
 BITVECTOR   *objGetBits      (OBJ_DATA *obj);
 
-void         objSetVnum      (OBJ_DATA *obj, int vnum);
+void         objSetClass     (OBJ_DATA *obj, const char *type);
+void         objSetPrototypes(OBJ_DATA *obj, const char *type);
+void         objAddPrototype (OBJ_DATA *obj, const char *type);
 void         objSetName      (OBJ_DATA *obj, const char *name);
 void         objSetKeywords  (OBJ_DATA *obj, const char *keywords);
 void         objSetRdesc     (OBJ_DATA *obj, const char *rdesc);
diff -ruN ../nakedmudv2.7/src/olc2/accedit.c src/olc2/accedit.c
--- ../nakedmudv2.7/src/olc2/accedit.c	Sun Jul 31 17:13:51 2005
+++ src/olc2/accedit.c	Fri Oct  7 14:15:55 2005
@@ -26,28 +26,6 @@
 
 
 
-//
-// Saves the account, updates all of the accounts with this name currently
-// in use, and deletes the account we're working with from memory.
-void accedit_cleanup(ACCOUNT_DATA *acct) {
-  LIST_ITERATOR *sock_i = newListIterator(socket_list);
-  SOCKET_DATA   *sock   = NULL;
-
-  // first, update all of the accounts online
-  ITERATE_LIST(sock, sock_i) {
-    if(socketGetAccount(sock) &&
-       !strcasecmp(accountGetName(socketGetAccount(sock)),
-		   accountGetName(acct)))
-      accountCopyTo(acct, socketGetAccount(sock));
-  } deleteListIterator(sock_i);
-
-  // now, save the account
-  save_account(acct);
-  // and free up the memory
-  deleteAccount(acct);
-}
-
-
 void accedit_menu(SOCKET_DATA *sock, ACCOUNT_DATA *acct) {
   LIST_ITERATOR *ch_i = newListIterator(accountGetChars(acct));
   char            *ch = NULL;
@@ -83,7 +61,9 @@
 		  const char *arg) {
   switch(choice) {
   case ACCEDIT_NEW_CHAR:
-    if(!char_exists(arg))
+    if(!*arg)
+      return TRUE;
+    else if(!player_exists(arg))
       return FALSE;
     else {
       listPutWith(accountGetChars(acct), strdup(arg), strcasecmp);
@@ -111,12 +91,12 @@
   if(!arg || !*arg)
     send_to_char(ch, "You must supply an account name, first!\r\n");
   else {
-    ACCOUNT_DATA *acct = load_account(arg);
+    ACCOUNT_DATA *acct = get_account(arg);
     if(acct == NULL)
       send_to_char(ch, "Account '%s' does not exist!\r\n", arg);
     else {
       do_olc(charGetSocket(ch), accedit_menu, accedit_chooser, accedit_parser,
-	     NULL, NULL, NULL, accedit_cleanup, acct);
+	     NULL, NULL, unreference_account, save_account, acct);
     }
   }
 }
diff -ruN ../nakedmudv2.7/src/olc2/esedit.c src/olc2/esedit.c
--- ../nakedmudv2.7/src/olc2/esedit.c	Sun Jul 31 17:13:50 2005
+++ src/olc2/esedit.c	Fri Oct  7 14:15:55 2005
@@ -27,7 +27,7 @@
 		 "{c%s\r\n"
 		 "{g2) Description\r\n"
 		 "{c%s\r\n",
-		 edescSetGetKeywords(edesc), 
+		 edescGetKeywords(edesc), 
 		 edescSetGetDesc(edesc)
 		 );
 }
@@ -72,7 +72,7 @@
   // print out each one
   for(i = 0; i < entries; i++)
     send_to_socket(sock, "  {g%2d) {c%s\r\n", i, 
-		   edescSetGetKeywords(edescSetGetNum(set, i)));
+		   edescGetKeywords(edescSetGetNum(set, i)));
   send_to_socket(sock,
 		 "\r\n"
 		 "{gE) edit entry\r\n"
